#include <stdio.h>

#define BP_WATER 100
#define BP_MERCURY 357
#define BP_COPPER 1187
#define BP_SILVER 2193
#define BP_GOLD 2660

/* Function Prototypes */
int within_x_percent(int ref, int data, int percent);

int main(void) {
    int within_x=5;
    int observed_bp;
    int found = 0;

    printf("What is the observed boiling point? ");
    scanf("%d",&observed_bp);

    printf("\nYour substance is within %d percent of:\n",within_x);
    if(within_x_percent(observed_bp,BP_WATER,within_x)) { 
	printf("water\n"); 
    } else if(within_x_percent(observed_bp,BP_MERCURY,within_x)) { 
	printf("mercury\n"); 
    } else if(within_x_percent(observed_bp,BP_COPPER,within_x)) { 
	printf("copper\n"); 
    } else if(within_x_percent(observed_bp,BP_SILVER,within_x)) { 
	printf("silver\n"); 
    } else if(within_x_percent(observed_bp,BP_GOLD,within_x)) { 
	printf("gold\n"); 
    } else {
	printf("Substance Unknown at 5%%.\n");	
    	printf("\nPlease enter another error margin (percentage)? ");
    	scanf("%d",&within_x);

	printf("\nAt %d%%, the substance(s) that match your boiling point:\n", within_x);

    	if(within_x_percent(observed_bp,BP_WATER,within_x)) { printf("water\n"); }
    	if(within_x_percent(observed_bp,BP_MERCURY,within_x)) { printf("mercury\n"); }
    	if(within_x_percent(observed_bp,BP_COPPER,within_x)) { printf("copper\n"); }
    	if(within_x_percent(observed_bp,BP_SILVER,within_x)) { printf("silver\n"); }
    	if(within_x_percent(observed_bp,BP_GOLD,within_x)) { printf("gold\n"); }

    }

    return 0;
}


/* Function Definitions */
int within_x_percent(int ref, int data, int percent) {
    int result = 0;
    double lower_bound, upper_bound;

    lower_bound = (double)ref - (percent/100.0) * ref;
    upper_bound = (double)ref + (percent/100.0) * ref;

    if(data >= lower_bound && data <= upper_bound) { result = 1; }

    return result;
}

