/*
 * Program name:  samlpe1.c
 * basic switch case structure
 *        Author: Cate Anderson, revised by Cory Strope
 *       Written: 2-22-06
 * Last revision: 7-22-06
 */

#include <stdio.h>
#include <stdlib.h>

/* Function prototypes */
int leap(int year);
int valid(int day, int month, int year);

int main()
{
	int month;
	int day;
	int year;
	int leapyear=0;
	int dayNum;
	
	printf("Enter the year => ");
	scanf("%d", &year);
	
	printf("Enter the month => ");
	scanf("%d", &month);
	
	printf("Enter the day => ");
	scanf("%d", &day);

 	if(!valid(day,month,year)) {
	    printf("Invalid day, month, year combo\n");
	    exit(0);
	}
	leapyear = leap(year);
	
	switch(month) {
	case 1:
		dayNum = day;		
		break;
	case 2: 
		dayNum = day + 31; 
		break;
	case 3: 
		dayNum = day+ 59 + leapyear;
		break;
	case 4: 
		dayNum = day + 90 + leapyear;  
		break;
	case 5: 
		dayNum = day + 120 + leapyear; 
		break;
	case 6: 
		dayNum = day + 151 + leapyear; 
		break;
	case 7: 
		dayNum = day + 181 + leapyear; 
		break;
	case 8: 
		dayNum = day + 212 + leapyear; 
		break;
	case 9: 
		dayNum = day + 243 + leapyear; 
		break;
	case 10: 
		dayNum = day + 273 + leapyear; 
		break;
	case 11: 
		dayNum = day + 304 + leapyear; 
		break;
	default:
		dayNum = day + 334 + leapyear; 
		break;
	}

	printf("\n%d-%d-%d is day %d\n", month, day, year, dayNum);	
			
	return 0;
}

/* Function Definitions */
int leap(int year) {
    int ans;

    if(year % 400 == 0) ans = 1;
    else if(year % 100 == 0) ans = 0;
    else if(year % 4 == 0) ans = 1;
    else ans = 0;

    return ans;
}

int valid(int day, int month, int year) {
    int ans;

    if(day < 1 || day > 30) ans = 0;
    else if(month < 1 || month > 12) ans = 0;
    else {
	switch(month) {
	case 4:
	case 6:
	case 9:
	case 11:
	    if(day > 30) ans = 0;
	    else ans = 1;
	    break;
        case 2:
	    if(leap(year))
		if(day > 29) ans = 0;
		else ans = 1;
	    else
		if(day > 28) ans = 0;
		else ans = 1;

	    break;
	default:
	    ans = 1;
        }
    }

    return ans;
}
