#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#define MAX_WIDTH 14
#define ALT_WIDTH 12

int width;

/* Function prototypes */
void Print_Man(int num_heads, int num_arms, int num_legs, int num_men);
void Print_Head(int num_heads, int num_men);
void Print_Body(int num_arms, int num_men);
void Print_Legs(int num_legs, int num_men);
int  Get_Num_Heads(void);
int  Get_Num_Arms(void);
int  Get_Num_Legs(void);

int main (void) {
    int num_heads;
    int num_arms;
    int num_legs;
    int num_men,i;
    
    printf("How many men do you want? ");
    scanf("%d", &num_men);

    num_heads = Get_Num_Heads();
    num_arms = Get_Num_Arms();
    num_legs = Get_Num_Legs();
    Print_Man(num_heads,num_arms,num_legs,num_men);

    return 0;
}

/* Function Definitions */
int Get_Num_Heads() {
    int heads = 0; 

    while(heads != 1 && heads != 2) {
        printf("How many heads (1 or 2)> ");
        scanf("%d",&heads);
    }

    if(heads == 1) width = ALT_WIDTH;
    else width = MAX_WIDTH;

    return heads;
}

int Get_Num_Arms() {
    int arms = 0; 

    while(arms != 1 && arms != 2) {
    	printf("How many sets of arms (1 or 2)> ");
    	scanf("%d",&arms);
    }

    return arms;
}

int Get_Num_Legs() {
    int legs = 0; 

    while(legs != 1 && legs != 2) {
    	printf("How many pairs of legs (1 or 2)> ");
    	scanf("%d",&legs);
    }

    return legs;
}

void Print_Man(int num_heads, int num_arms, int num_legs, int num_men) {
    Print_Head(num_heads,num_men);
    Print_Body(num_arms,num_men);
    Print_Legs(num_legs,num_men);
}

void Print_Head(int num_heads, int num_men) {
    int i,j;

    if(num_heads == 1) {
        for(i=0; i<num_men; i++)
	    for(j=printf("      *  "); j<width; j++) printf(" ");
	printf("\n");
        for(i=0; i<num_men; i++)
    	    for(j=printf("    *'_'*   ");j<width; j++) printf(" ");
	printf("\n");
        for(i=0; i<num_men; i++)
    	    for(j=printf("      *   "); j<width; j++) printf(" ");
	printf("\n");
    } else if (num_heads == 2) {
        for(i=0; i<num_men; i++)
            for(j=printf("   *     * ");j<width; j++) printf(" ");
	printf("\n");
        for(i=0; i<num_men; i++)
    	    for(j=printf(" *'_'* *'_'*  ");j<width; j++) printf(" ");
	printf("\n");
        for(i=0; i<num_men; i++)
    	    for(j=printf("   *     * ");j<width; j++) printf(" ");
	printf("\n");
        for(i=0; i<num_men; i++)
    	    for(j=printf("    \\_ _/ ");j<width; j++) printf(" ");
	printf("\n");
    } else {
	printf("Invalid number of heads.\n");
	exit(0);
    }

}

void Print_Body(int num_arms,int num_men) {
    int i,j;

    for(i=0; i<num_men; i++) 
    	for(j=printf("      |  ");j<width; j++) printf(" ");
    printf("\n");
    for(i=0; i<num_men; i++) 
    	for(j=printf("    \\_|_/");j<width; j++) printf(" ");
    printf("\n");
    for(i=0; i<num_men; i++) 
    	for(j=printf("      |");j<width; j++) printf(" ");
    printf("\n");

    if(num_arms == 2) {
    	for(i=0; i<num_men; i++) 
	    for(j=printf("     _|_");j<width; j++) printf(" ");
    	printf("\n");
    	for(i=0; i<num_men; i++) 
    	    for(j=printf("    / | \\");j<width; j++) printf(" ");
    	printf("\n");
    	for(i=0; i<num_men; i++) 
    	    for(j=printf("      |");j<width; j++) printf(" ");
    	printf("\n");
    }
}

void Print_Legs(int num_legs, int num_men) {
    int i,j;

    if(num_legs > 1) {
    	for(i = 0; i<num_men; i++) 
    	    for(j=printf("     _|_   ");j<width; j++) printf(" ");
    	printf("\n");
    	for(i = 0; i<num_men; i++) 
	    for(j=printf("   \\// \\\\/");j<width; j++) printf(" ");
    	printf("\n");
    } else { 
    	for(i = 0; i<num_men; i++) 
	    for(j=printf("     / \\ ");j<width; j++) printf(" ");
    	printf("\n");
    }
    for(i = 0; i<num_men; i++) 
    	for(j=printf("   _/   \\_ ");j<width; j++) printf(" ");
    printf("\n");
}

